#include <windows.h>
#include <plugin.hpp>

void WINAPI _export SetStartupInfo(struct PluginStartupInfo *PSI) {
}

HANDLE WINAPI _export OpenFilePlugin(char *Name, const unsigned char *Data, int DataSize) {

	if(stricmp("AUTORUN.INF", strrchr(Name, '\\')+1)==0) {
		int posS=0, posT=0;
		char OemBuffer[MAX_PATH];
		char CommandAnsi[MAX_PATH];
		char ParametersAnsi[MAX_PATH];
		char endChar;
		SHELLEXECUTEINFO ExecCommand;

		while(posS < DataSize) {
			if( Data[posS]=='\n') {
				// skip leading spaces in new string
				while((Data[++posS]<=' ') && (posS<DataSize));

				if(strnicmp("open", ((char*)Data)+posS, 4)==0) {
					posS += 4;
					// skip all spaces after keyword 'open'
					while( (posS<DataSize) && ((Data[++posS]==' ') || (Data[posS]=='\t')) );
					if(Data[posS] == '=') {

						// Initilize execute structure
						memset(&ExecCommand, 0, sizeof(SHELLEXECUTEINFO));
						ExecCommand.cbSize = sizeof(SHELLEXECUTEINFO);
						ExecCommand.lpFile = CommandAnsi;
						ExecCommand.nShow  = SW_SHOWNORMAL;

						// skip all spaces after equal sign
						while( (posS<DataSize) && ((Data[++posS]==' ') || (Data[posS]=='\t')) );

						// check, is program name in quotes or no
						if(Data[posS]=='"') {
							endChar='"';
							posS++;
						} else endChar=0;

						// read program name
						while((endChar=='"') ? (Data[posS]!='"') : (Data[posS]>=' ')) {
							OemBuffer[posT++] = Data[posS++];
						}
						// remove right spaces from program name if it is not in quotes
						if(endChar!='"') {
							while(OemBuffer[--posT]<=' ');
						} else {
							posT--;
							posS++;
						}
						OemBuffer[posT+1]=0;
						// convert command name from OEM to ANSI
						OemToChar(OemBuffer, CommandAnsi);

						if(Data[posS]!=0) {
							// read parameters
							while((posS<DataSize) && (Data[posS]<=' ')) posS++;
							posT = 0;
							while((posS<DataSize) && ((Data[posS]>=' ') || (Data[posS]=='\t'))) {
								OemBuffer[posT++] = Data[posS++];
							}
							OemBuffer[posT]=0;

							// convert parameters from OEM to ANSI
							OemToChar(OemBuffer, ParametersAnsi);
							ExecCommand.lpParameters = ParametersAnsi;
						}

						// execute program
						ShellExecuteEx(&ExecCommand);
						// say to FAR: It was my file, don't try to start it yourself
						return (HANDLE)-2;
					}
				}
			}
			posS++;
		}
	}
	// it was not AUTORUN.INF or we didn't find keyword 'open' in it
	return INVALID_HANDLE_VALUE;
}